import sqlite3 from 'sqlite3'
import { open } from 'sqlite'

let db;

async function initDb() {
    if (db) return db;
    db = await open({
        filename: `${process.cwd()}/db/main.db`,
        driver: sqlite3.Database
    });

    await db.run('CREATE TABLE IF NOT EXISTS auth ( \
        username TEXT, \
        password TEXT \
    )');

    await db.run('CREATE TABLE IF NOT EXISTS token ( \
        username TEXT, \
        token TEXT \
    )');

    await db.run('CREATE TABLE IF NOT EXISTS project (username TEXT, title TEXT, id TEXT, date REAL, root TEXT, parent TEXT, status TEXT);');

    await db.run('CREATE TABLE IF NOT EXISTS comment (username TEXT, targetType TEXT, targetId TEXT, date REAL, content TEXT, id TEXT);');

    await db.run('CREATE TABLE IF NOT EXISTS follow (target TEXT, actor TEXT);');

    await db.run('CREATE TABLE IF NOT EXISTS studio (title TEXT, id TEXT, date REAL, desc TEXT);');

    await db.run('CREATE TABLE IF NOT EXISTS studioUser (username TEXT, studio TEXT, role TEXT);');

    await db.run('CREATE TABLE IF NOT EXISTS studioProject (project TEXT, studio TEXT, role TEXT);');

    await db.run('CREATE TABLE IF NOT EXISTS user (bio TEXT, username TEXT, role TEXT);');

    await db.run('CREATE TABLE IF NOT EXISTS ban (time REAL, username TEXT, type TEXT, reason TEXT);');

    await db.run('CREATE TABLE IF NOT EXISTS asset (id TEXT, username TEXT);');

    return db;
}

export {
    initDb
};